<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaGrrfmagnet extends \Doctrine\ORM\EntityRepository {
    
    public function retornaRegistros($mesCompetencia, $nrOrg, $cdOperador){
        $grrfMagnet = Repositories::FPA_GRRFMAGNET;
        $params = array('nrorg'=>$nrOrg, 'cdoperador'=>$cdOperador, 'dtmescompetenc'=>$mesCompetencia);
        
$sql = <<<SQL
    SELECT g FROM $grrfMagnet g
    WHERE g.nrorg = :nrorg 
    AND g.cdoperinclusao = :cdoperador
    AND g.mescompetencia = :dtmescompetenc
    ORDER BY g.idtpinscestrutu, g.cdinscestrut, g.idtpinscesttoma, g.cdinscestrutoma, g.nrpispaseppes, g.idtiporegistro
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaRegistrosPorTipo($mesCompetencia, $listaTipoRegistro, $nrOrg, $cdOperador){
        $grrfMagnet = Repositories::FPA_GRRFMAGNET;
        
        $listaTipoRegistro = preg_split('/[\s,]+/', $listaTipoRegistro);
        $params = array('nrorg'=>$nrOrg, 'cdoperador'=>$cdOperador, 'dtmescompetenc'=>$mesCompetencia, 'listatiporegistro' => $listaTipoRegistro);
        
$sql = <<<SQL
    SELECT g FROM $grrfMagnet g
    WHERE g.nrorg = :nrorg 
    AND g.idtiporegistro in (:listatiporegistro)
    AND g.cdoperinclusao = :cdoperador
    AND g.mescompetencia = :dtmescompetenc
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retornaRegistrosTrabalhador($mesCompetencia,$cdOperador,$nrOrg,$tipoRegistro,$tipoInscricao,$nrInscricao,
        $nrPisPasepCi,$dataAdmissao,$categoriaTrabalhador){
        $grrfMagnet = Repositories::FPA_GRRFMAGNET;
        $params = array('nrorg'=>$nrOrg, 'cdoperador'=>$cdOperador, 'dtmescompetenc'=>$mesCompetencia,
        'tiporegistro' => $tipoRegistro, 'tipoinscricao' => $tipoInscricao, 'nrinscricao' => $nrInscricao,
        'nrpispasepci' => $nrPisPasepCi, 'dataadmissao' => $dataAdmissao, 'categoriatrabalhador' => $categoriaTrabalhador);
        
$sql = <<<SQL
    SELECT g FROM $grrfMagnet g
    WHERE 
    g.mescompetencia = :dtmescompetenc AND
    g.cdoperinclusao = :cdoperador AND
    g.nrorg = :nrorg AND
    g.idtiporegistro = :tiporegistro AND
    g.idtpinscestrutu = :tipoinscricao AND
    g.cdinscestrut = :nrinscricao AND
    g.nrpispaseppes = :nrpispasepci AND
    g.dtadmissaovinc = :dataadmissao AND
    g.idcategtrab = :categoriatrabalhador 
    
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;    
    }

    public function getFgtsMesAnterior($nrvinculom,$nrOrg,$dtinicio,$dtfim){
        
        $grrfMagnet = Repositories::FPA_GRRFMAGNET;
        $params = array('nrorg'=>$nrOrg, 'nrvinculom'=>$nrvinculom, 'dtinicio'=>$dtinicio, 'dtfim'=>$dtfim);
        
$sql = <<<SQL
    SELECT g FROM $grrfMagnet g
    WHERE g.nrorg = :nrorg 
    AND g.nrvinculom = :nrvinculom
    AND (g.mescompetencia BETWEEN :dtinicio AND :dtfim)
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function retroceder($mesCompetencia, $nrOrg, $cdOperInclusao){
        
        $grrfMagnet = Repositories::FPA_GRRFMAGNET;
        $params = array('mescompetencia'=>$mesCompetencia, 'nrorg'=>$nrOrg, 'cdoperinclusao'=>$cdOperInclusao);
        
$sql = <<<SQL
    DELETE FROM $grrfMagnet g
    WHERE g.nrorg = :nrorg 
    AND g.mescompetencia = :mescompetencia
    AND g.cdoperinclusao = :cdoperinclusao
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
}